﻿local _
--按alt一次买一组
local savedMerchantItemButton_OnModifiedClick = MerchantItemButton_OnModifiedClick 
function MerchantItemButton_OnModifiedClick(self, ...) 
   if ( IsAltKeyDown() ) then 
      local itemLink = GetMerchantItemLink(self:GetID()) 
      if not itemLink then return end 
      local maxStack = select(8, GetItemInfo(itemLink)) 
      if ( maxStack and maxStack > 1 ) then 
         BuyMerchantItem(self:GetID(), GetMerchantItemMaxStack(self:GetID())) 
      end 
   end 
   savedMerchantItemButton_OnModifiedClick(self, ...) 
end
--[[拍卖行一键购买 ## Author: 苏彩彩
local AH = CreateFrame("Frame")
AH:SetScript("OnEvent", function(f, e, ...)
    if BuyoutCheckButton == nil then
        CreateFrame("CheckButton", "BuyoutCheckButton", AuctionFrameBrowse, "UICheckButtonTemplate")
        BuyoutCheckButton:SetPoint("LEFT", BrowseDropDownButton, "RIGHT", 100, 13)
        BuyoutCheckButton:SetSize(24, 24)
		BuyoutCheckButton:SetChecked(true)
        BuyoutCheckButtonText:SetFontObject(GameFontHighlightSmall);
        BuyoutCheckButtonText:SetText("|cff00EE00一键购买");
		CreateFrame("CheckButton", "BuyCheckButton", AuctionFrameBrowse, "UICheckButtonTemplate")
        BuyCheckButton:SetPoint("LEFT", BrowseDropDownButton, "RIGHT", 100, -9)
        BuyCheckButton:SetSize(24, 24)
        BuyCheckButtonText:SetFontObject(GameFontHighlightSmall);
        BuyCheckButtonText:SetText("|cff00EE00自动确认");
        hooksecurefunc("BrowseButton_OnClick", function(button)
            if BuyCheckButton:GetChecked() then
                if AuctionFrame.buyoutPrice > 100000000 then
                    StaticPopup_Show("BUYOUT_AUCTION");
                else
                    PlaceAuctionBid(AuctionFrame.type, GetSelectedAuctionItem(AuctionFrame.type), AuctionFrame.buyoutPrice)
                end
			elseif BuyoutCheckButton:GetChecked() then
				StaticPopup_Show("BUYOUT_AUCTION");
            end
        end)
    end
end)
AH:RegisterEvent("AUCTION_HOUSE_SHOW")

-- 拍卖行单价
local function formats(value)
	local str = ''
	if value > 9999 then
		str = str .. format('|c00ffd700%d金|r', floor(value / 10000))
	end
	if value > 99 and floor(value/100)%100 ~= 0 then
		str = str .. format('|c00c7c7cf%d银|r', (floor(value / 100) % 100))
	end
	if floor(value)%100 ~= 0 then
		str = str .. format('|c00eda55f%d铜|r', (floor(value) % 100))
	end
	return str
end

hooksecurefunc("AuctionFrame_LoadUI", function()
	if AuctionFrameBrowse_Update then
		hooksecurefunc("AuctionFrameBrowse_Update", function()
			local numBatchAuctions = GetNumAuctionItems("list")
			local offset = FauxScrollFrame_GetOffset(BrowseScrollFrame)
			for i=1, NUM_BROWSE_TO_DISPLAY do
				local index = offset + i + (NUM_AUCTION_ITEMS_PER_PAGE * AuctionFrameBrowse.page)
				if index <= numBatchAuctions + (NUM_AUCTION_ITEMS_PER_PAGE * AuctionFrameBrowse.page) then
					local name, _, count, _, _, _, _, _, _, buyoutPrice, bidAmount =  GetAuctionItemInfo("list", offset + i)
					local alpha = 0.5
					local color = "yellow"
					if name then
						local itemName = _G["BrowseButton"..i.."Name"]
						local moneyFrame = _G["BrowseButton"..i.."MoneyFrame"]
						local buyoutMoney = _G["BrowseButton"..i.."BuyoutFrameMoney"]
						if (buyoutPrice/10000) >= 5000 then color = "red" end
						if bidAmount > 0 then
							name = name .. " |cffffff00[拍]|r"
							alpha = 1.0
						end
						if (buyoutPrice > 0) and (count >1) then
							name = name .. " |cffffff00("..formats(floor(buyoutPrice / count)).."|cffffff00)|r"
						end
						itemName:SetText(name)
						moneyFrame:SetAlpha(alpha)
						SetMoneyFrameColor(buyoutMoney:GetName(), color)
					end
				end
			end
		end)
	end
end)]]